#include <stdlib.h>
#include <stdint.h>
#include <assert.h>

unsigned int nondet_uint();

#define assert2(x, y) __CPROVER_assert(x, y)
#define assume(x) __CPROVER_assume(x)

#ifndef V
#define V 3
#endif

#ifndef C
#define C 3
#endif

unsigned int voting(unsigned int votes[], unsigned int numVotes) {
    unsigned int res[C + 1];
    unsigned int i = 0;

    for (i = 0; i < numVotes; i++) {
        assume (0 < votes[i] && votes[i] <= C);
    }

    for (i = 0; i <= C; i++) {
        res[i] = 0;
    }
    for (i = 0; i < numVotes; i++) {
        res[votes[i]]++;
    }
    unsigned int max = 0;
    unsigned int elect = 0;
    for (i = 1; i <= C; i++) {
        if (max < res[i]) {
            max = res[i];
            elect = i;
        } else {
            if (max == res[i]) {
                elect = 0;
            }
        }
    }
    return elect;
}

void consistency(unsigned int votes[V]) {
    unsigned int i = 0;
    unsigned int sep = nondet_uint();
    assume (0 < sep && sep < V);

    unsigned int votes1[sep];
    for (i = 0; i < sep; i++) {
	votes1[i] = votes[i];
    }
    unsigned int votes2[V - sep];
    for (i = sep; i < V; i++) {
	votes2[i - sep] = votes[i];
    }

    unsigned int elect1 = voting(votes1, sep);
    unsigned int elect2 = voting(votes2, V - sep);

    if (elect1 != 0 && elect1 == elect2) {
	unsigned int elect = voting(votes, V);
	assert (elect1 == elect);
    }
}

int main(int argc, char *argv[]) {
    unsigned int i = 0;
    unsigned int v1[V];
    for (i = 0; i < V; i++) {
        v1[i] = nondet_uint();
    }

    consistency(v1);
    return 0;
}
