#include <stdlib.h>
#include <stdint.h>
#include <assert.h>

unsigned int nondet_uint();

#define assert2(x, y) __CPROVER_assert(x, y)
#define assume(x) __CPROVER_assume(x)

#ifndef V
#define V 3
#endif

#ifndef C
#define C 3
#endif

unsigned int voting(unsigned int votes[V]) {
    unsigned int res[C + 1];
    unsigned int i = 0;

    for (i = 0; i < V; i++) {
        assume (0 < votes[i] && votes[i] <= C);
    }

    for (i = 0; i <= C; i++) {
        res[i] = 0;
    }
    for (i = 0; i < V; i++) {
        res[votes[i]]++;
    }
    unsigned int max = 0;
    unsigned int elect = 0;
    for (i = 1; i <= C; i++) {
        if (max < res[i]) {
            max = res[i];
            elect = i;
        } else {
            if (max == res[i]) {
                elect = 0;
            }
        }
    }
    return elect;
}

void majority(unsigned int votes[V]) {
    unsigned int i = 0;
    unsigned int quota = V / 2;
    unsigned int sum[C+1];

    unsigned int elect = voting(votes);

    for (i = 0; i <= C; i++) {
	sum[i] = 0;
    }
    for (i = 0; i < V; i++) {
	sum[votes[i]]++;
    }
    for (i = 1; i < C; i++) {
	if (quota < sum[i]) {
	    assert (elect == i);
	}
    }
}

int main(int argc, char *argv[]) {
    unsigned int i = 0;
    unsigned int v1[V];
    for (i = 0; i < V; i++) {
        v1[i] = nondet_uint();
    }

    majority(v1);
    return 0;
}
