#include <stdlib.h>
#include <stdint.h>
#include <assert.h>

unsigned int nondet_uint();

#define assert2(x, y) __CPROVER_assert(x, y)
#define assume(x) __CPROVER_assume(x)

#ifndef V
#define V 3
#endif

#ifndef C
#define C 3
#endif

unsigned int voting(unsigned int votes[V]) {
    unsigned int res[C + 1];
    unsigned int i = 0;

    for (i = 0; i < V; i++) {
        assume (0 < votes[i] && votes[i] <= C);
    }

    for (i = 0; i <= C; i++) {
        res[i] = 0;
    }
    for (i = 0; i < V; i++) {
        res[votes[i]]++;
    }
    unsigned int max = 0;
    unsigned int elect = 0;
    for (i = 1; i <= C; i++) {
        if (max < res[i]) {
            max = res[i];
            elect = i;
        } else {
            if (max == res[i]) {
                elect = 0;
            }
        }
    }
    return elect;
}

void monotonicity(unsigned int votes1[V], unsigned int votes2[V],
		  unsigned int m, unsigned int n) {
    assume (0 < m && m <= C);
    assume (0 <= n && n < V);
    unsigned int i = 0;

    for (i = 0; i < V; i++) {
        if (i != n) {
            assume (votes1[i] == votes2[i]);
        }
    }

    assume (votes1[n] != m);
    assume (votes2[n] == m);

    unsigned int elect1 = voting(votes1);
    unsigned int elect2 = voting(votes2);
     if (m == elect1) {
        assert (elect1 == elect2);
     }
}

int main(int argc, char *argv[]) {
    unsigned int i = 0;
    unsigned int v1[V];
    unsigned int v2[V];
    for (i = 0; i < V; i++) {
        v1[i] = nondet_uint();
	v2[i] = nondet_uint();
    }
    unsigned int vote  = nondet_uint();
    unsigned int voter = nondet_uint();

    monotonicity(v1, v2, vote, voter);
    return 0;
}
